/* 
 * Thomas Pantzer: februar_cb.cc, Version: v0.1a  11.02.2000 04:06 
 * 
 * 
 * Copyright 2000 by Thomas Pantzer
 * 
 * Permission to use, copy, modify, and distribute this software for noncommercial 
 * use and without fee is hereby granted, provided that the above copyright notice 
 * appear in all copies and that both that copyright notice and this permission 
 * notice appear in supporting documentation, and that the name of the Author not be 
 * used in advertising or publicity pertaining to distribution of the software 
 * without specific, written prior permission. The Author makes no representations about
 * the suitability of this software for any purpose.  It is provided "as is" 
 * without expressed or implied warranty. 
 * 
 * 
 * pantec@isys2.informatik.uni-leipzig.de   (Thomas Pantzer) 
 * 
 */



#include <time.h>
#include "forms.h"
#include "februar.h"
#include "copyright.h"



char minset = false;
char hourset = false;
char yearset = false;


double minfrac = 0.0;
double hourfrac = 0.0;

int birthyear;
int thisyear = 1999;

/* callbacks for form feb */
void input_cb(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
	char s[256]; 
	int m,y,h;

	strcpy(s,fl_get_input(ob));

	switch (data)
	  {
	   case _cmd_exit:
	     exit(0);
	     break;

	   case _cmd_min:
	     if (sscanf(s,"%d",&m) == 1)
	        {
	     	 minset = true;
	         minfrac = (double)m / (24.0*60.0);
	        }
              else 
	        return;
	     break;

	   case _cmd_hour:
	     if (sscanf(s,"%d",&h) == 1)
	        {
	     	 hourset = true;
	         hourfrac = (double)h / (24.0);
	        }
              else 
	        return;
	     break;

	   case _cmd_year:
	     if (sscanf(s,"%d",&y) == 1)
	        {
	     	 yearset = true; 
	         if (y < 100)
	            birthyear = 1900 + y;
		  else 
		    birthyear = y;
	        }
              else 
	        return;
	     break;
	  }


        time_t my_time;                                                                         
	struct tm *lt;
	char st[256];	
                                                                                                
        time(&my_time);                                                                         
	lt = localtime(&my_time);

	if (lt != NULL)
	   {
#ifdef DEBUG
	    printf("got year %d\n",lt->tm_year+1900); 	
#endif
	    thisyear = lt->tm_year+1900; 
	   }

	if ((minset == false) || (hourset == false) || (yearset == false))
	   return;

	int v = timecalc(birthyear,thisyear,minfrac + hourfrac);

	switch (v)
          { 
	   case 0:
	     sprintf(st,"am 28. Februar");
	     break;

	   case 1:
	     sprintf(st,"am 29. Februar");
             break;

	   case 2:
             sprintf(st,"am 1. Mrz");
             break;
          } 


	char msg[256];
        sprintf(msg,"Deinen Geburtstag feierst Du in diesem\nJahr am besten %s",st);	
	fl_set_object_label(fd_feb->suggest_box,msg);
}



